{   Denis Butorin. 26.09.02, E-Mail: subritto@ngs.ru; 
Web: http://subritto.h1.ru}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ToolWin, ComCtrls, ExtCtrls, StdCtrls, Speech, ActiveX, ComObj;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    Speak: TSpeedButton;
    PauseSpeak: TSpeedButton;
    Stop: TSpeedButton;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpeakClick(Sender: TObject);
    procedure PauseSpeakClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
  private
    { Private declarations }
    fITTSCentral: ITTSCentral; { ,
            }
    fIAMM: IAudioMultimediaDevice;
      {     }
    aTTSEnum: ITTSEnum;
      {   }
    fpModeInfo: PTTSModeInfo;
      {   }
    Pause: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  NumFound : DWord;
  ModeInfo : TTSModeInfo;
begin
  try
    {  }
    CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL,
           IID_IAudioMultiMediaDevice, fIAMM);
  except
  end;
  {        
      ITTSEnum}
  CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
  aTTSEnum.Reset;//  
  aTTSEnum.Next(1, ModeInfo, @NumFound); {  }
  While NumFound > 0 do
   begin
     ComboBox1.Items.Add(String(ModeInfo.szModeName));
     aTTSEnum.Next(1, ModeInfo, @NumFound); { }
   end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
 NumFound: DWord;
 ModeInfo : TTSModeInfo;{     }
begin
   try
     CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL,
          IID_IAudioMultiMediaDevice, fIAMM);
     CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
     aTTSEnum.Reset;
     {   }
     Form1.aTTSEnum.skip(ComboBox1.ItemIndex);
     aTTSEnum.Next(1, ModeInfo, @NumFound);
     if assigned(fpModeInfo) then
     { fpModeInfo   nil}
      dispose(fpModeInfo);
     new(fpModeInfo);
     fpModeInfo^:=ModeInfo;
     { }
     aTTSEnum.Select(fpModeInfo^.gModeID, fITTSCentral, IUnknown(fIAMM));
   except
   end;
end;

procedure TForm1.SpeakClick(Sender: TObject);
var
  SData: TSData;
  BufRich: string;
begin
  if not assigned(fITTSCentral) then
   begin
    ShowMessage(' !');
    exit;
   end;
  BufRich:=copy(RichEdit1.Text, RichEdit1.SelStart,
                        length(RichEdit1.Text)-RichEdit1.SelStart);
  SData.dwSize := length(BufRich) + 1;
  SData.pData := pChar(BufRich);
  if pause then
   begin
    try
      fITTSCentral.AudioResume;
      Pause:=False;
    except
      exit;
    end;
   end
  else
   begin
    try
      fITTSCentral.TextData(CHARSET_TEXT, 0, SData, nil,
                                            IID_ITTSBufNotifySink);
    except
    end;
   end;
end;

procedure TForm1.PauseSpeakClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
   begin
    ShowMessage(' !');
    exit;
   end;
  if Pause then
    exit;
  try
    fITTSCentral.AudioPause;
    pause:=True;
  except
  end;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  if not assigned(fITTSCentral) then
   begin
    showmessage(' !');
    exit;
   end;
  try
    fITTSCentral.AudioReset;
    Pause:=False;
  except
  end;
end;

end.
